# special thanks to kkeithley for using his wizard rpm skills to get this going
%global puppet_module_version 0.0.3

Name:		puppet-gluster
Version:	0.0.3
#Release:	1%{?dist}	# use this to make dist specific builds
Release:	1
Summary:	A puppet module for GlusterFS
License:	AGPLv3+
URL:		https://github.com/purpleidea/puppet-gluster
Source0:	https://download.gluster.org/pub/gluster/purpleidea/puppet-gluster/SOURCES/puppet-gluster-%{puppet_module_version}.tar.bz2
BuildArch:	noarch

Requires: puppet >= 3.0.0
Requires: puppetlabs-stdlib >= 4.1.0

# these should be 'Suggests:' or similar, since they aren't absolutely required
#Requires: puppetlabs-apt >= 1.4.0
Requires: puppet-common >= 0.0.1
Requires: puppet-keepalived >= 0.0.1
Requires: puppet-puppet >= 0.0.1
Requires: puppet-shorewall >= 0.0.1
Requires: puppet-yum >= 0.0.1

%description
A puppet module used for installing, configuring and managing GlusterFS.

%prep
%setup -c -q -T -D -a 0

find %{_builddir} -type f -name ".*" -exec rm {} +
find %{_builddir} -size 0 -exec rm {} +
find %{_builddir} \( -name "*.pl" -o -name "*.sh"  \) -exec chmod +x {} +
find %{_builddir} \( -name "*.pp" -o -name "*.py"  \) -exec chmod -x {} +
find %{_builddir} \( -name "*.rb" -o -name "*.erb" \) -exec chmod -x {} + -exec sed -i "/^#!/{d;q}" {} +

%build

%install
rm -rf %{buildroot}
# _datadir is typically /usr/share/
install -d -m 0755 %{buildroot}/%{_datadir}/puppet/modules/
cp -r puppet-gluster-%{puppet_module_version} %{buildroot}/%{_datadir}/puppet/modules/gluster

%files
%{_datadir}/puppet/modules/*

# this changelog is auto-generated by git log
%changelog
* Wed May 7 2014 James Shubin <james@shubin.ca>
- (36ee0eb) Release 0.0.3 (HEAD, master)

* Tue May 6 2014 James Shubin <james@shubin.ca>
- (6733de7) The xml.py file should be executable to help downstream packagers. (origin/master, glusterforge/master, fedora/master)

* Tue May 6 2014 James Shubin <james@shubin.ca>
- (afc480f) Set the libvirt driver to use accelerated kvm.

* Tue May 6 2014 James Shubin <james@shubin.ca>
- (130abef) Add FAQ item about common puppet failures and the workaround.

* Mon May 5 2014 James Shubin <james@shubin.ca>
- (a80a7a6) Support adding multiple additional disks to gluster machines.

* Mon May 5 2014 James Shubin <james@shubin.ca>
- (a3f50eb) Let the sync type be configurable.

* Wed Apr 23 2014 James Shubin <purpleidea@redhat.com>
- (80c2b13) Add an extra mkfs blocker. (origin/bug/gilles)

* Thu Apr 10 2014 James Shubin <james@shubin.ca>
- (b948c83) Include glusterfs-api package for client and server.

* Thu Apr 10 2014 James Shubin <james@shubin.ca>
- (b0f645e) Support LVM thin provisioning.

* Thu Apr 10 2014 James Shubin <james@shubin.ca>
- (b5e8342) Make Exec['again'] optional. As a result puppet-common is optional.

* Thu Apr 10 2014 James Shubin <james@shubin.ca>
- (c1e6e03) Allow raid_su and raid_sw to be blank, even if it is not recommended.

* Thu Apr 10 2014 James Shubin <james@shubin.ca>
- (117ac5c) Remove leading colons.

* Tue Apr 8 2014 James Shubin <james@shubin.ca>
- (29adf91) Create management network from a single variable.

* Fri Apr 4 2014 James Shubin <james@shubin.ca>
- (e6f0bc5) Store different os versions in different output directories.

* Thu Mar 27 2014 James Shubin <james@shubin.ca>
- (2419569) Include spec file and infrastructure for making RPMS. (origin/rpm, rpm)

* Mon Mar 24 2014 James Shubin <james@shubin.ca>
- (fc962a6) Refactor the previous patch for the sake of future maintainability.

* Mon Mar 24 2014 James Shubin <james@shubin.ca>
- (cc6db62) Add per brick defaults to gluster::simple for easier [physical] clusters.

* Tue Mar 18 2014 James Shubin <james@shubin.ca>
- (7c423fa) Add a link to the documentation. (redhatstaging/master)

* Tue Mar 18 2014 James Shubin <james@shubin.ca>
- (c7a0914) Add a symlink from DOCUMENTATION.md to README.md so docs are visible.

* Mon Mar 17 2014 James Shubin <james@shubin.ca>
- (f46d916) Update documentation to reflect new features.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (8139b89) Improved UUID validation logic for manual UUID selection. (redhatstaging/rhs, origin/rhs, glusterforge/rhs, fedorahosted/rhs, fedora/rhs, rhs)

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (2cea9a9) Type name should be 'array', not 'list'.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (1677bdd) Add typing for storage-{uid,gid} volume properties.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (a78ffe5) Small fixes for automatic fsuuid to be more robust.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (c7a6ef2) Add automatic generation of fs UUID's per brick filesystem.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (05576cd) Setting volume properties should be race-free.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (fbe9e9c) Improve brick count input and parsing.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (7102088) Silence unnecessary warnings if we know they're unnecessary.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (e367d10) Plug in volume layout and setgroups into vagrant.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (e69ea49) Fix small chaining bugs.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (ea15eda) Fix small bugs with chaining.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (595e33c) Remove algorithmic brick layout ordering that happens in the fact.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (1707802) Add per volume support for brick chaining.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (1152b69) Fix small bugs and warnings.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (0f11f74) Fix small bugs for setgroups.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (70b41db) Add advanced set group support for anyone without stock support.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (7057c91) Small fixes to avoid warnings.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (dd44a55) Add support for volume set groups.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (2dd6acd) Directory variables should be nil if invalid.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (2804934) Add in a custom sponge utility to break the dependence on the EPEL repo.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (905afa1) Make use of ping (actually, fping) optional in gluster::simple.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (12df64b) Allow specifying brick device and other parameters in gluster::simple.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (06454f4) Lower case use of k, not upper case, as per performance documentation.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (2ca6cd2) Small LVM fixes.

* Sun Mar 16 2014 James Shubin <james@shubin.ca>
- (5391f06) Add LVM support, and use recommended xfs settings, as per RHS.

* Tue Mar 11 2014 James Shubin <james@shubin.ca>
- (3838149) Update the puppet submodule.

* Tue Mar 11 2014 James Shubin <james@shubin.ca>
- (a62f770) Add in a commented out prefix option.

* Mon Mar 3 2014 James Shubin <james@shubin.ca>
- (99005a8) Double the default power of the puppet vm.

* Tue Feb 4 2014 James Shubin <james@shubin.ca>
- (37d21df) Add consistent arg ordering.

* Mon Jan 27 2014 James Shubin <james@shubin.ca>
- (d7fec30) Update .gitignore file.

* Mon Jan 27 2014 James Shubin <james@shubin.ca>
- (864362c) Catch empty arrays.

* Fri Jan 24 2014 James Shubin <james@shubin.ca>
- (0191594) Small bugfixes.

* Fri Jan 24 2014 James Shubin <james@shubin.ca>
- (7448b47) Add support for more volume options.

* Fri Jan 24 2014 James Shubin <james@shubin.ca>
- (221e304) Add support for setting: 'rpc-auth-allow-insecure' in glusterd.vol. (origin/feat/for-semiosis, feat/for-semiosis)

* Thu Jan 23 2014 James Shubin <james@shubin.ca>
- (b0f905c) Add support for specifying the base-port option in glusterd.vol (origin/feat/baseport)

* Tue Jan 21 2014 James Shubin <james@shubin.ca>
- (7f48c51) Add client entries to their /etc/hosts so that puppet sees the FQDN.

* Tue Jan 21 2014 James Shubin <james@shubin.ca>
- (756dadb) Update builder Makefile to enable SELinux and run the relabelling. (feat/builderselinux)

* Tue Jan 21 2014 James Shubin <james@shubin.ca>
- (b195f6b) Add more notes from rwmjones.

* Tue Jan 21 2014 James Shubin <james@shubin.ca>
- (a9e809f) Add support for setting the replica through vagrant.

* Tue Jan 21 2014 James Shubin <james@shubin.ca>
- (51fea72) Add client mounting and associated magic.

* Tue Jan 21 2014 James Shubin <james@shubin.ca>
- (bee4993) Disable cachier by default until author is more responsive.

* Mon Jan 20 2014 James Shubin <james@shubin.ca>
- (bafb07e) Add short README for builder process.

* Thu Jan 16 2014 James Shubin <james@shubin.ca>
- (30392fd) Add support for automatic qa-release detection.

* Thu Jan 16 2014 James Shubin <james@shubin.ca>
- (856ebf4) Be more correct with how we run make and fail.

* Wed Jan 15 2014 James Shubin <james@shubin.ca>
- (2b3b367) Use the latest shorewall to avoid some warnings.

* Wed Jan 15 2014 James Shubin <james@shubin.ca>
- (48455ac) Make it easier to enable/disable the firewall.

* Mon Jan 13 2014 James Shubin <james@shubin.ca>
- (de7bca1) Update documentation to mention vagrant.

* Sat Jan 11 2014 James Shubin <james@shubin.ca>
- (1b53a7c) Builder scripts for building vagrant base image "boxes".

* Wed Jan 8 2014 James Shubin <james@shubin.ca>
- (ddd1f66) This is Puppet-Gluster+Vagrant! (https://ttboj.wordpress.com/)

* Sat Jan 4 2014 James Shubin <james@shubin.ca>
- (36275d4) Keepalived should properly integrate with shorewall zone.

* Thu Jan 2 2014 James Shubin <james@shubin.ca>
- (d2b1e38) Try and pick the _right_ default IP address.

* Tue Dec 31 2013 James Shubin <james@shubin.ca>
- (f646fd6) The volume create script shouldn't depend on VIP existence.

* Tue Dec 31 2013 James Shubin <james@shubin.ca>
- (f533720) Update template variables to use the '@' prefix.

* Tue Dec 31 2013 James Shubin <james@shubin.ca>
- (2b1e94f) Add VRRP integration. (vrrp)

* Sat Dec 28 2013 James Shubin <james@shubin.ca>
- (a8d2d9f) Properly iterate over all the peers.

* Tue Dec 24 2013 James Shubin <james@shubin.ca>
- (fcd9ec7) Updated shell scripts to use sponge.

* Tue Dec 24 2013 James Shubin <james@shubin.ca>
- (680a787) Added preliminary Exec['again'] support to puppet-gluster.

* Mon Dec 23 2013 James Shubin <james@shubin.ca>
- (a28e8e4) README maintenance

* Sun Dec 22 2013 James Shubin <james@shubin.ca>
- (eac2c8f) Removed three (mostly) harmless slashes.

* Sun Dec 22 2013 James Shubin <james@shubin.ca>
- (ca290d4) Improved auto repo management and version selection.

* Tue Dec 17 2013 James Shubin <james@shubin.ca>
- (8ebe677) Add missing line from gluster packages.

* Tue Dec 17 2013 James Shubin <james@shubin.ca>
- (735df01) Catch DNS errors more easily.

* Tue Dec 17 2013 James Shubin <james@shubin.ca>
- (562da97) Automatically add yum repository.

* Sat Dec 14 2013 James Shubin <james@shubin.ca>
- (7b96488) Fixed small typo.

* Thu Dec 12 2013 James Shubin <james@shubin.ca>
- (1f58e5d) Suppress warnings when gluster is not installed.

* Mon Nov 18 2013 James Shubin <james@shubin.ca>
- (afc3358) Updated documentation.

* Mon Nov 18 2013 James Shubin <james@shubin.ca>
- (30fde0b) Added documentation to Puppet-Gluster.

* Wed Oct 30 2013 James Shubin <james@shubin.ca>
- (1568e40) Attempt to make puppet-gluster friendly for puppet forge users.

* Wed Oct 30 2013 James Shubin <james@shubin.ca>
- (54d19de) Woops, tiny bugfix.

* Tue Oct 29 2013 James Shubin <james@shubin.ca>
- (c65d77e) Globals should be in CAPS.

* Sat Oct 26 2013 James Shubin <james@shubin.ca>
- (3e8c4bf) Set the generated UUID to have the value of the user generated one.

* Sat Oct 26 2013 James Shubin <james@shubin.ca>
- (fa5af57) Ensure user selected UUID's are valid.

* Sat Oct 26 2013 James Shubin <james@shubin.ca>
- (e71fb3b) Small fixes for gluster::simple.

* Thu Oct 10 2013 James Shubin <james@shubin.ca>
- (db0e06f) Automatic brick ordering and finite state machine support.

* Thu Oct 10 2013 James Shubin <james@shubin.ca>
- (b9153d8) Module needs a better description.

* Thu Oct 10 2013 James Shubin <james@shubin.ca>
- (24ef469) Small VIP fixes.

* Thu Oct 10 2013 James Shubin <james@shubin.ca>
- (392308c) Use better namespacing for volume create tmp log files.

* Mon Sep 23 2013 James Shubin <james@shubin.ca>
- (2aa4163) Add gluster version fact and operating-version templating.

* Thu Sep 19 2013 James Shubin <james@shubin.ca>
- (17aff1a) Give glusterd a chance to settle down before we create a volume.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (fa3fd2e) Added fancy volume creation.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (d1a2fb7) Better notification of glusterd reloads.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (a1cccc4) Set operating-version in glusterd.info

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (2ade18f) Small cleanups.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (21fd59f) Also verify peer state for connection tool.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (58aae6a) Added short comment.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (99b5c5c) Misc comments.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (b3a75df) Additional UUID facts.

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (4dbba38) Finally, Fancy Firewalling...

* Wed Sep 18 2013 James Shubin <james@shubin.ca>
- (269be1c) Updated xml parser with new features...

* Mon Sep 16 2013 James Shubin <james@shubin.ca>
- (3e9feb8) Nitpick cleanups.

* Mon Sep 16 2013 James Shubin <james@shubin.ca>
- (7e00d90) Better volume property management.

* Mon Sep 16 2013 James Shubin <james@shubin.ca>
- (1d423ad) Some initial firewalling cleanups.

* Sun Sep 8 2013 James Shubin <james@shubin.ca>
- (9c30b8e) Allow empty ips list.

* Sun Sep 8 2013 James Shubin <james@shubin.ca>
- (3b4421c) Remove unnecessary folder creation.

* Sun Sep 8 2013 James Shubin <james@shubin.ca>
- (5e51cc3) Better slash handling

* Sun Sep 8 2013 James Shubin <james@shubin.ca>
- (2b0f3e4) Remove redundant hosts specification in gluster::server()

* Sun Sep 8 2013 James Shubin <james@shubin.ca>
- (24844a8) This patch adds fact magic to make specifying host uuid's optional.

* Sat Sep 7 2013 James Shubin <james@shubin.ca>
- (7c2dc0c) Set proper selinux context and perms. Keep Dan Walsh from crying.

* Sat Sep 7 2013 James Shubin <james@shubin.ca>
- (231e4b9) Make it easier to use simple filesystem paths for bricks.

* Sat Sep 7 2013 James Shubin <james@shubin.ca>
- (4345cf9) Add proper ping/status checks before volume creation.

* Fri Sep 6 2013 James Shubin <james@shubin.ca>
- (64aaaf3) Small bugfixes.

* Tue Aug 20 2013 James Shubin <james@shubin.ca>
- (89dd93e) Small cleanups.

* Sun Jun 23 2013 James Shubin <james@shubin.ca>
- (94454ea) Added a puppet-{gluster,nfs,ipa} example.

* Sun Jun 23 2013 James Shubin <james@shubin.ca>
- (781df95) Added my .gitignore

* Tue Jun 4 2013 James Shubin <james@shubin.ca>
- (1acec77) I was bored, so I updated all the numbers!

* Tue Jun 4 2013 James Shubin <james@shubin.ca>
- (d352c07) Doc fixes

* Mon Jun 3 2013 James Shubin <james@shubin.ca>
- (2a65757) Cleanup some small things.

* Thu Jan 10 2013 James Shubin <james@shubin.ca>
- (9aae259) Improved split logic.

* Thu Jan 10 2013 James Shubin <james@shubin.ca>
- (af3dc90) Fix xml paths.

* Thu Jan 10 2013 James Shubin <james@shubin.ca>
- (4e68eca) Small nitpicks

* Tue Nov 20 2012 James Shubin <james@shubin.ca>
- (b9085d2) Prevent duplicate definition when in noop mode.

* Thu Aug 23 2012 James Shubin <james@shubin.ca>
- (f9aaa75) Cleaned up examples and added ::client.

* Thu Aug 23 2012 James Shubin <james@shubin.ca>
- (f4dd756) Experimental gluster::wrapper support.

* Thu Aug 23 2012 James Shubin <james@shubin.ca>
- (f6966c0) Cluster VIP management.

* Thu Aug 23 2012 James Shubin <james@shubin.ca>
- (78c9207) Autotyping support for ::property

* Thu Aug 23 2012 James Shubin <james@shubin.ca>
- (293f0ce) Small comment changes.

* Fri Jul 27 2012 James Shubin <james@shubin.ca>
- (bda440c) Fixed typo.

* Fri Jul 27 2012 James Shubin <james@shubin.ca>
- (35830b0) Forgot to add the xml.py parser.

* Fri Jul 27 2012 James Shubin <james@shubin.ca>
- (35b3381) Cleaned up firewalling slightly.

* Fri Jul 27 2012 James Shubin <james@shubin.ca>
- (ab471b4) Set volume properties.

* Fri Jul 27 2012 James Shubin <james@shubin.ca>
- (00c0043) Sadly, I could not read my own code, so I had to revert back to tabs. Sorry bodepd!

* Fri Jul 27 2012 James Shubin <james@shubin.ca>
- (954431b) Updated README file.

* Fri Jul 27 2012 James Shubin <james@shubin.ca>
- (a473b31) Whitespace cleanup.

* Thu Jul 26 2012 James Shubin <james@shubin.ca>
- (d079937) Split fs dependencies into separate files.

* Thu Jul 26 2012 James Shubin <james@shubin.ca>
- (04b30ca) Change tabs to spaces as per bodepd's insistence :)

* Tue Jul 24 2012 James Shubin <james@shubin.ca>
- (61cf89a) Initial commit. puppet-gluster, welcome to git.

